=== modified file 'plugin/pbxt/tests/t/basic_auto_increment.test'
--- plugin/pbxt/tests/t/basic_auto_increment.test	2010-09-23 23:37:18 +0000
+++ plugin/pbxt/tests/t/basic_auto_increment.test	2010-10-08 17:09:37 +0000
@@ -1,4 +1,5 @@
 --source include/have_linux.inc
+--source include/have_valgrind.inc
 SET SESSION storage_engine=pbxt;
 create table t1 (a int auto_increment primary key);
 insert into t1 values (),(),(),();

=== modified file 'plugin/pbxt/tests/t/basic_create_nullable.test'
--- plugin/pbxt/tests/t/basic_create_nullable.test	2010-09-23 23:37:18 +0000
+++ plugin/pbxt/tests/t/basic_create_nullable.test	2010-10-08 17:09:37 +0000
@@ -1,4 +1,5 @@
 --source include/have_linux.inc
+--source include/have_valgrind.inc
 SET SESSION storage_engine=pbxt;
 create table t1 (a int, b int not null, c int null, d int not null, pk int primary key);
 show create table t1;

=== modified file 'plugin/pbxt/tests/t/basic_create_select.test'
--- plugin/pbxt/tests/t/basic_create_select.test	2010-09-24 22:07:08 +0000
+++ plugin/pbxt/tests/t/basic_create_select.test	2010-10-08 17:09:37 +0000
@@ -1,4 +1,5 @@
 --source include/have_linux.inc
+--source include/have_valgrind.inc
 SET SESSION storage_engine=pbxt;
 create table t1 (d int primary key);
 create table t2 (d int primary key);

=== modified file 'plugin/pbxt/tests/t/basic_create_table.test'
--- plugin/pbxt/tests/t/basic_create_table.test	2010-09-23 23:37:18 +0000
+++ plugin/pbxt/tests/t/basic_create_table.test	2010-10-08 17:09:37 +0000
@@ -1,4 +1,5 @@
 --source include/have_linux.inc
+--source include/have_valgrind.inc
 SET SESSION storage_engine=pbxt;
 CREATE TABLE t1 (a int primary key);
 SHOW CREATE TABLE t1;

=== modified file 'plugin/pbxt/tests/t/basic_create_with_index.test'
--- plugin/pbxt/tests/t/basic_create_with_index.test	2010-09-23 23:37:18 +0000
+++ plugin/pbxt/tests/t/basic_create_with_index.test	2010-10-08 17:09:37 +0000
@@ -1,4 +1,5 @@
 --source include/have_linux.inc
+--source include/have_valgrind.inc
 SET SESSION storage_engine=pbxt;
 CREATE TABLE t1 (a int primary key);
 SHOW CREATE TABLE t1;

=== modified file 'plugin/pbxt/tests/t/basic_delete_all_rows.test'
--- plugin/pbxt/tests/t/basic_delete_all_rows.test	2010-09-23 23:37:18 +0000
+++ plugin/pbxt/tests/t/basic_delete_all_rows.test	2010-10-08 17:09:37 +0000
@@ -1,4 +1,5 @@
 --source include/have_linux.inc
+--source include/have_valgrind.inc
 SET SESSION storage_engine=pbxt;
 CREATE TABLE t1 (a int primary key);
 insert into t1 values (1),(2),(3);

=== modified file 'plugin/pbxt/tests/t/basic_delete_row.test'
--- plugin/pbxt/tests/t/basic_delete_row.test	2010-09-23 23:37:18 +0000
+++ plugin/pbxt/tests/t/basic_delete_row.test	2010-10-08 17:09:37 +0000
@@ -1,4 +1,5 @@
 --source include/have_linux.inc
+--source include/have_valgrind.inc
 SET SESSION storage_engine=pbxt;
 CREATE TABLE t1 (a int primary key);
 insert into t1 values (1),(2),(3),(4),(5),(6);

=== modified file 'plugin/pbxt/tests/t/basic_drop_table.test'
--- plugin/pbxt/tests/t/basic_drop_table.test	2010-09-23 23:37:18 +0000
+++ plugin/pbxt/tests/t/basic_drop_table.test	2010-10-08 17:09:37 +0000
@@ -1,4 +1,5 @@
 --source include/have_linux.inc
+--source include/have_valgrind.inc
 SET SESSION storage_engine=pbxt;
 CREATE TABLE t1 (a int primary key);
 CREATE TABLE t2 (a int primary key);

=== modified file 'plugin/pbxt/tests/t/basic_index_lookup.test'
--- plugin/pbxt/tests/t/basic_index_lookup.test	2010-09-24 22:07:08 +0000
+++ plugin/pbxt/tests/t/basic_index_lookup.test	2010-10-08 17:09:37 +0000
@@ -1,4 +1,5 @@
 --source include/have_linux.inc
+--source include/have_valgrind.inc
 SET SESSION storage_engine=pbxt;
 create table t1 (a int primary key);
 insert into t1 values (1),(2),(3),(4),(100),(200);

=== modified file 'plugin/pbxt/tests/t/basic_innodb_truncate_table.test'
--- plugin/pbxt/tests/t/basic_innodb_truncate_table.test	2010-09-23 23:37:18 +0000
+++ plugin/pbxt/tests/t/basic_innodb_truncate_table.test	2010-10-08 17:09:37 +0000
@@ -1,4 +1,5 @@
 --source include/have_linux.inc
+--source include/have_valgrind.inc
 SET SESSION storage_engine=pbxt;
 CREATE TABLE t1 (a int PRIMARY KEY);
 insert into t1 values (1),(2),(3),(4);

=== modified file 'plugin/pbxt/tests/t/basic_insert.test'
--- plugin/pbxt/tests/t/basic_insert.test	2010-09-23 23:37:18 +0000
+++ plugin/pbxt/tests/t/basic_insert.test	2010-10-08 17:09:37 +0000
@@ -1,4 +1,5 @@
 --source include/have_linux.inc
+--source include/have_valgrind.inc
 SET SESSION storage_engine=pbxt;
 create table t1 (a int primary key);
 insert into t1 (a) values (1);

=== modified file 'plugin/pbxt/tests/t/basic_insert_multi_column.test'
--- plugin/pbxt/tests/t/basic_insert_multi_column.test	2010-09-23 23:37:18 +0000
+++ plugin/pbxt/tests/t/basic_insert_multi_column.test	2010-10-08 17:09:37 +0000
@@ -1,4 +1,5 @@
 --source include/have_linux.inc
+--source include/have_valgrind.inc
 SET SESSION storage_engine=pbxt;
 create table t1 (a int primary key, b varchar(10));
 insert into t1 (a,b) values (1, 'hello');

=== modified file 'plugin/pbxt/tests/t/basic_insert_pkey_duplicate.test'
--- plugin/pbxt/tests/t/basic_insert_pkey_duplicate.test	2010-09-23 23:37:18 +0000
+++ plugin/pbxt/tests/t/basic_insert_pkey_duplicate.test	2010-10-08 17:09:37 +0000
@@ -1,4 +1,5 @@
 --source include/have_linux.inc
+--source include/have_valgrind.inc
 SET SESSION storage_engine=pbxt;
 create table t1 (a int primary key);
 insert into t1 values (1);

=== modified file 'plugin/pbxt/tests/t/basic_pkey_index_reverse_scan.test'
--- plugin/pbxt/tests/t/basic_pkey_index_reverse_scan.test	2010-09-24 22:07:08 +0000
+++ plugin/pbxt/tests/t/basic_pkey_index_reverse_scan.test	2010-10-08 17:09:37 +0000
@@ -1,4 +1,5 @@
 --source include/have_linux.inc
+--source include/have_valgrind.inc
 SET SESSION storage_engine=pbxt;
 create table t1 (a int primary key);
 insert into t1 values (1),(2),(3);

=== modified file 'plugin/pbxt/tests/t/basic_pkey_index_scan.test'
--- plugin/pbxt/tests/t/basic_pkey_index_scan.test	2010-09-24 22:07:08 +0000
+++ plugin/pbxt/tests/t/basic_pkey_index_scan.test	2010-10-08 17:09:37 +0000
@@ -1,4 +1,5 @@
 --source include/have_linux.inc
+--source include/have_valgrind.inc
 SET SESSION storage_engine=pbxt;
 CREATE TABLE t1 (a int primary key);
 insert into t1 values (1),(2);

=== modified file 'plugin/pbxt/tests/t/basic_rename_table.test'
--- plugin/pbxt/tests/t/basic_rename_table.test	2010-09-23 23:37:18 +0000
+++ plugin/pbxt/tests/t/basic_rename_table.test	2010-10-08 17:09:37 +0000
@@ -1,4 +1,5 @@
 --source include/have_linux.inc
+--source include/have_valgrind.inc
 SET SESSION storage_engine=pbxt;
 create table t1 (a int primary key);
 rename table t1 to t2;

=== modified file 'plugin/pbxt/tests/t/basic_select.test'
--- plugin/pbxt/tests/t/basic_select.test	2010-09-23 23:37:18 +0000
+++ plugin/pbxt/tests/t/basic_select.test	2010-10-08 17:09:37 +0000
@@ -1,4 +1,5 @@
 --source include/have_linux.inc
+--source include/have_valgrind.inc
 SET SESSION storage_engine=pbxt;
 create table t1 (a int primary key);
 insert into t1 (a) values (1);

=== modified file 'plugin/pbxt/tests/t/basic_select_multirow.test'
--- plugin/pbxt/tests/t/basic_select_multirow.test	2010-09-23 23:37:18 +0000
+++ plugin/pbxt/tests/t/basic_select_multirow.test	2010-10-08 17:09:37 +0000
@@ -1,4 +1,5 @@
 --source include/have_linux.inc
+--source include/have_valgrind.inc
 SET SESSION storage_engine=pbxt;
 create table t1 (a int primary key);
 insert into t1 (a) values (1),(2),(3),(4);

=== modified file 'plugin/pbxt/tests/t/basic_show_tables.test'
--- plugin/pbxt/tests/t/basic_show_tables.test	2010-09-23 23:37:18 +0000
+++ plugin/pbxt/tests/t/basic_show_tables.test	2010-10-08 17:09:37 +0000
@@ -1,4 +1,5 @@
 --source include/have_linux.inc
+--source include/have_valgrind.inc
 SET SESSION storage_engine=pbxt;
 CREATE TABLE t1 (a int primary key);
 show tables;

=== modified file 'plugin/pbxt/tests/t/basic_transaction.test'
--- plugin/pbxt/tests/t/basic_transaction.test	2010-09-23 23:37:18 +0000
+++ plugin/pbxt/tests/t/basic_transaction.test	2010-10-08 17:09:37 +0000
@@ -1,4 +1,5 @@
 --source include/have_linux.inc
+--source include/have_valgrind.inc
 SET SESSION storage_engine=pbxt;
 connect (con1,localhost,root,,);
 connect (con2,localhost,root,,);

=== modified file 'plugin/pbxt/tests/t/basic_transaction_autocommit.test'
--- plugin/pbxt/tests/t/basic_transaction_autocommit.test	2010-09-23 23:37:18 +0000
+++ plugin/pbxt/tests/t/basic_transaction_autocommit.test	2010-10-08 17:09:37 +0000
@@ -1,4 +1,5 @@
 --source include/have_linux.inc
+--source include/have_valgrind.inc
 SET SESSION storage_engine=pbxt;
 connect (con1,localhost,root,,);
 connect (con2,localhost,root,,);

=== modified file 'plugin/pbxt/tests/t/basic_transaction_rollback.test'
--- plugin/pbxt/tests/t/basic_transaction_rollback.test	2010-09-24 22:07:08 +0000
+++ plugin/pbxt/tests/t/basic_transaction_rollback.test	2010-10-08 17:09:37 +0000
@@ -1,4 +1,5 @@
 --source include/have_linux.inc
+--source include/have_valgrind.inc
 SET SESSION storage_engine=pbxt;
 CREATE TABLE t1 (a int primary key);
 INSERT INTO t1 VALUES (1);

=== modified file 'plugin/pbxt/tests/t/basic_type_decimal.test'
--- plugin/pbxt/tests/t/basic_type_decimal.test	2010-09-23 23:37:18 +0000
+++ plugin/pbxt/tests/t/basic_type_decimal.test	2010-10-08 17:09:37 +0000
@@ -1,4 +1,5 @@
 --source include/have_linux.inc
+--source include/have_valgrind.inc
 SET SESSION storage_engine=pbxt;
 CREATE TABLE t1 (a decimal(2,1));
 insert into t1 values (1.0),(1.1),(2.0);

=== modified file 'plugin/pbxt/tests/t/basic_update.test'
--- plugin/pbxt/tests/t/basic_update.test	2010-09-23 23:37:18 +0000
+++ plugin/pbxt/tests/t/basic_update.test	2010-10-08 17:09:37 +0000
@@ -1,4 +1,5 @@
 --source include/have_linux.inc
+--source include/have_valgrind.inc
 SET SESSION storage_engine=pbxt;
 create table t1(a int primary key);
 insert into t1 values (1);

=== modified file 'plugin/pbxt/tests/t/basic_with_indexes.test'
--- plugin/pbxt/tests/t/basic_with_indexes.test	2010-09-23 23:37:18 +0000
+++ plugin/pbxt/tests/t/basic_with_indexes.test	2010-10-08 17:09:37 +0000
@@ -1,4 +1,5 @@
 --source include/have_linux.inc
+--source include/have_valgrind.inc
 SET SESSION storage_engine=pbxt;
 CREATE TABLE t1 (a int primary key, b int);
 insert into t1 values (1,1);

=== modified file 'plugin/pbxt/tests/t/master.opt'
--- plugin/pbxt/tests/t/master.opt	2010-09-15 20:09:56 +0000
+++ plugin/pbxt/tests/t/master.opt	2010-10-08 17:09:37 +0000
@@ -1,1 +1,1 @@
---plugin-add=pbxt 
+--plugin-add=pbxt --plugin-add=utility_dictionary

=== modified file 'plugin/utility_dictionary/environmental.cc'
--- plugin/utility_dictionary/environmental.cc	2010-10-04 04:37:03 +0000
+++ plugin/utility_dictionary/environmental.cc	2010-10-08 17:09:37 +0000
@@ -51,9 +51,6 @@
   if (not *position)
     return false;
 
-  std::string substring(*position, 0, LARGEST_ENV_STRING);
-  push(substring);
-
   char *value= NULL;
   if ((value= strchr(*position, '=')))
   {
@@ -62,11 +59,15 @@
 
   if (value)
   {
+    std::string substring(*position, 0, (size_t)(value - *position -1)); // The additional -1 is for the = 
+    push(substring);
+
     substring.assign(value, 0, LARGEST_ENV_STRING);
     push(substring);
   }
   else
   {
+    std::string substring(*position, 0, LARGEST_ENV_STRING);
     push(false);
   }
   

=== added file 'tests/include/have_valgrind.inc'
--- tests/include/have_valgrind.inc	1970-01-01 00:00:00 +0000
+++ tests/include/have_valgrind.inc	2010-10-08 17:09:37 +0000
@@ -0,0 +1,4 @@
+-- require r/have_valgrind.require
+disable_query_log;
+select COUNT(*) as c from data_dictionary.environmental WHERE Variable_name="VALGRIND_RUN";
+enable_query_log;

=== added file 'tests/r/have_valgrind.require'
--- tests/r/have_valgrind.require	1970-01-01 00:00:00 +0000
+++ tests/r/have_valgrind.require	2010-10-08 17:09:37 +0000
@@ -0,0 +1,2 @@
+c
+0

=== modified file 'tests/test-run.pl'
--- tests/test-run.pl	2010-09-28 21:14:58 +0000
+++ tests/test-run.pl	2010-10-08 17:09:37 +0000
@@ -870,6 +870,7 @@
     $opt_valgrind= 1;
     $opt_valgrind_mysqld= 1;
     $opt_valgrind_drizzletest= 1;
+    $ENV{'VALGRIND_RUN'} = '1';
   }
   elsif ( $opt_valgrind_mysqld )
   {

